--- a/debugfs/debugfs.c
+++ b/debugfs/debugfs.c
@@ -322,14 +322,19 @@
 		retval = ext2fs_write_inode_bitmap(current_fs);
 		if (retval)
 			com_err("ext2fs_write_inode_bitmap", retval, 0);
+		ext2fs_mark_ib_dirty(current_fs);
 	}
 	if (current_fs->flags & EXT2_FLAG_BB_DIRTY) {
 		retval = ext2fs_write_block_bitmap(current_fs);
 		if (retval)
 			com_err("ext2fs_write_block_bitmap", retval, 0);
+		ext2fs_mark_bb_dirty(current_fs);
 	}
 	if (current_qctx)
 		quota_release_context(&current_qctx);
+	retval = ext2fs_flush(current_fs);
+	if (retval)
+		com_err("ext2fs_flush", retval, 0);
 	retval = ext2fs_close_free(&current_fs);
 	if (retval)
 		com_err("ext2fs_close", retval, 0);
